package jrummikub;

import javax.swing.UIManager;

import jrummikub.control.RoundControl;
import jrummikub.model.GameState;
import jrummikub.model.Position;
import jrummikub.model.Stone;
import jrummikub.model.StoneSet;
import jrummikub.view.impl.View;

public class JRummikub {

	public static void main(String[] args) {
		String nativeLF = UIManager.getSystemLookAndFeelClassName();

		try {
			UIManager.setLookAndFeel(nativeLF);
		} catch (Exception e) {
		}

		GameState gameState = new GameState();
		View view = new View();

		for (Stone stone : gameState.getGameHeap().drawStones(5)) {
			gameState.getTable().drop(new StoneSet(stone), new Position(0, 0));
		}

		RoundControl roundControl = new RoundControl(gameState, view);
		roundControl.startRound();

	}

}
